"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.require = exports.requests = void 0;
const http2 = require("http2");
const proxyquire = require("proxyquire");
exports.requests = [];
// eslint-disable-next-line @typescript-eslint/no-explicit-any
function req(modulePath, additionalStubs = {}) {
    const stubs = {
        http2: {
            connect: (target, connectionOptions) => {
                const session = http2.connect(target, connectionOptions);
                const originalRequest = session.request;
                session.request = requestHeaders => {
                    exports.requests.push(requestHeaders);
                    return originalRequest.call(session, requestHeaders);
                };
                return session;
            },
            '@global': true,
        },
    };
    return proxyquire(modulePath, Object.assign(additionalStubs, stubs));
}
exports.require = req;
//# sourceMappingURL=index.js.map